Index: sasmodels/convert.py
===================================================================
--- sasmodels/convert.py	(revision 51241113b3f18a1a2b9aea3eaf8c2eaad5b8560a)
+++ sasmodels/convert.py	(revision 07c8d460b7b27e8016df36dcd00643a649cd4e71)
@@ -2,11 +2,12 @@
 Convert models to and from sasview.
 """
-from __future__ import print_function
-
-from os.path import join as joinpath, abspath, dirname
+from __future__ import print_function, division
+
+import re
 import math
 import warnings
 
 from .conversion_table import CONVERSION_TABLE
+from .core import load_model_info
 
 # List of models which SasView versions don't contain the explicit 'scale' argument.
@@ -17,5 +18,4 @@
     'two_lorentzian',
     "two_power_law",
-    'gel_fit',
     'gauss_lorentz_gel',
     'be_polyelectrolyte',
@@ -49,10 +49,78 @@
 # Convert new style names for polydispersity info to old style names
 PD_DOT = [
-    ("", ""),
     ("_pd", ".width"),
     ("_pd_n", ".npts"),
     ("_pd_nsigma", ".nsigmas"),
     ("_pd_type", ".type"),
+    (".lower", ".lower"),
+    (".upper", ".upper"),
+    (".fittable", ".fittable"),
+    (".std", ".std"),
+    (".units", ".units"),
+    ("", "")
     ]
+
+def _rescale(par, scale):
+    return [pk*scale for pk in par] if isinstance(par, list) else par*scale
+
+def _is_sld(model_info, id):
+    """
+    Return True if parameter is a magnetic magnitude or SLD parameter.
+    """
+    if id.startswith('M0:'):
+        return True
+    if '_pd' in id or '.' in id:
+        return False
+    for p in model_info.parameters.call_parameters:
+        if p.id == id:
+            return p.type == 'sld'
+    # check through kernel parameters in case it is a named as a vector
+    for p in model_info.parameters.kernel_parameters:
+        if p.id == id:
+            return p.type == 'sld'
+    return False
+
+def _rescale_sld(model_info, pars, scale):
+    """
+    rescale all sld parameters in the new model definition by *scale* so the
+    numbers are nicer.  Relies on the fact that all sld parameters in the
+    new model definition end with sld.  For backward conversion use
+    *scale=1e-6*.  For forward conversion use *scale=1e6*.
+    """
+    return dict((id, (_rescale(v, scale) if _is_sld(model_info, id) else v))
+                for id, v in pars.items())
+
+
+def _get_translation_table(model_info, version=(3,1,2)):
+    conv_param = CONVERSION_TABLE.get(version, {}).get(model_info.id, [None, {}])
+    translation = conv_param[1].copy()
+    for p in model_info.parameters.kernel_parameters:
+        if p.length > 1:
+            newid = p.id
+            oldid = translation.get(p.id, p.id)
+            translation.pop(newid, None)
+            for k in range(1, p.length+1):
+                if newid+str(k) not in translation:
+                    translation[newid+str(k)] = oldid+str(k)
+    # Remove control parameter from the result
+    if model_info.control:
+        translation[model_info.control] = "CONTROL"
+    return translation
+
+# ========= FORWARD CONVERSION sasview 3.x => sasmodels ===========
+def _dot_pd_to_underscore_pd(par):
+    if par.endswith(".width"):
+        return par[:-6]+"_pd"
+    elif par.endswith(".type"):
+        return par[:-5]+"_pd_type"
+    elif par.endswith(".nsigmas"):
+        return par[:-8]+"_pd_nsigma"
+    elif par.endswith(".npts"):
+        return par[:-5]+"_pd_n"
+    else:
+        return par
+
+def _pd_to_underscores(pars):
+    return dict((_dot_pd_to_underscore_pd(k), v) for k, v in pars.items())
 
 def _convert_pars(pars, mapping):
@@ -63,61 +131,210 @@
     for new, old in mapping.items():
         if old == new: continue
+        if old is None: continue
         for underscore, dot in PD_DOT:
-            if old+dot in newpars:
+            source = old+dot
+            if source in newpars:
                 if new is not None:
-                    newpars[new+underscore] = pars[old+dot]
-                del newpars[old+dot]
+                    target = new+dot
+                else:
+                    target = None
+                if source != target:
+                    if target:
+                        newpars[target] = pars[old+dot]
+                    del newpars[source]
     return newpars
 
-def convert_model(name, pars):
+def _conversion_target(model_name, version=(3,1,2)):
+    """
+    Find the sasmodel name which translates into the sasview name.
+
+    Note: *CoreShellEllipsoidModel* translates into *core_shell_ellipsoid:1*.
+    This is necessary since there is only one variant in sasmodels for the
+    two variants in sasview.
+    """
+    for sasmodels_name, sasview_dict in \
+            CONVERSION_TABLE.get(version, {}).items():
+        if sasview_dict[0] == model_name:
+            return sasmodels_name
+    return None
+
+def _hand_convert(name, oldpars, version=(3,1,2)):
+    if version == (3,1,2):
+        oldpars = _hand_convert_3_1_2_to_4_1(name, oldpars)
+    return oldpars
+
+def _hand_convert_3_1_2_to_4_1(name, oldpars):
+    if name == 'core_shell_parallelepiped':
+        # Make sure pd on rim parameters defaults to zero
+        # ... probably not necessary.
+        oldpars['rimA.width'] = 0.0
+        oldpars['rimB.width'] = 0.0
+        oldpars['rimC.width'] = 0.0
+    elif name == 'core_shell_ellipsoid:1':
+        # Reverse translation (from new to old), from core_shell_ellipsoid.c
+        #    equat_shell = equat_core + thick_shell
+        #    polar_core = equat_core * x_core
+        #    polar_shell = equat_core * x_core + thick_shell*x_polar_shell
+        # Forward translation (from old to new), inverting reverse translation:
+        #    thick_shell = equat_shell - equat_core
+        #    x_core = polar_core / equat_core
+        #    x_polar_shell = (polar_shell - polar_core)/(equat_shell - equat_core)
+        # Auto translation (old <=> new) happens after hand_convert
+        #    equat_shell <=> thick_shell
+        #    polar_core <=> x_core
+        #    polar_shell <=> x_polar_shell
+        # So...
+        equat_core, equat_shell = oldpars['equat_core'], oldpars['equat_shell']
+        polar_core, polar_shell = oldpars['polar_core'], oldpars['polar_shell']
+        oldpars['equat_shell'] = equat_shell - equat_core
+        oldpars['polar_core'] = polar_core / equat_core
+        oldpars['polar_shell'] = (polar_shell-polar_core)/(equat_shell-equat_core)
+    elif name == 'hollow_cylinder':
+        # now uses radius and thickness
+        thickness = oldpars['radius'] - oldpars['core_radius']
+        oldpars['radius'] = thickness
+        if 'radius.width' in oldpars:
+            pd = oldpars['radius.width']*oldpars['radius']/thickness
+            oldpars['radius.width'] = pd
+    elif name == 'multilayer_vesicle':
+        if 'scale' in oldpars:
+            oldpars['volfraction'] = oldpars['scale']
+            oldpars['scale'] = 1.0
+        if 'scale.lower' in oldpars:
+            oldpars['volfraction.lower'] = oldpars['scale.lower']
+        if 'scale.upper' in oldpars:
+            oldpars['volfraction.upper'] = oldpars['scale.upper']
+        if 'scale.fittable' in oldpars:
+            oldpars['volfraction.fittable'] = oldpars['scale.fittable']
+        if 'scale.std' in oldpars:
+            oldpars['volfraction.std'] = oldpars['scale.std']
+        if 'scale.units' in oldpars:
+            oldpars['volfraction.units'] = oldpars['scale.units']
+    elif name == 'pearl_necklace':
+        pass
+        #_remove_pd(oldpars, 'num_pearls', name)
+        #_remove_pd(oldpars, 'thick_string', name)
+    elif name == 'polymer_micelle':
+        if 'ndensity' in oldpars:
+            oldpars['ndensity'] /= 1e15
+        if 'ndensity.lower' in oldpars:
+            oldpars['ndensity.lower'] /= 1e15
+        if 'ndensity.upper' in oldpars:
+            oldpars['ndensity.upper'] /= 1e15
+    elif name == 'rpa':
+        # convert scattering lengths from femtometers to centimeters
+        for p in "L1", "L2", "L3", "L4":
+            if p in oldpars:
+                oldpars[p] /= 1e-13
+            if p + ".lower" in oldpars:
+                oldpars[p + ".lower"] /= 1e-13
+            if p + ".upper" in oldpars:
+                oldpars[p + ".upper"] /= 1e-13
+    elif name == 'spherical_sld':
+        j = 0
+        while "func_inter" + str(j) in oldpars:
+            name = "func_inter" + str(j)
+            new_name = "shape" + str(j + 1)
+            if oldpars[name] == 'Erf(|nu|*z)':
+                oldpars[new_name] = int(0)
+            elif oldpars[name] == 'RPower(z^|nu|)':
+                oldpars[new_name] = int(1)
+            elif oldpars[name] == 'LPower(z^|nu|)':
+                oldpars[new_name] = int(2)
+            elif oldpars[name] == 'RExp(-|nu|*z)':
+                oldpars[new_name] = int(3)
+            elif oldpars[name] == 'LExp(-|nu|*z)':
+                oldpars[new_name] = int(4)
+            else:
+                oldpars[new_name] = int(0)
+            oldpars.pop(name)
+            oldpars['n_shells'] = str(j + 1)
+            j += 1
+    elif name == 'teubner_strey':
+        # basically undoing the entire Teubner-Strey calculations here.
+        #    drho = (sld_a - sld_b)
+        #    k = 2.0*math.pi*xi/d
+        #    a2 = (1.0 + k**2)**2
+        #    c1 = 2.0 * xi**2 * (1.0 - k**2)
+        #    c2 = xi**4
+        #    prefactor = 8.0*math.pi*phi*(1.0-phi)*drho**2*c2/xi
+        #    scale = 1e-4*prefactor
+        #    oldpars['scale'] = a2/scale
+        #    oldpars['c1'] = c1/scale
+        #    oldpars['c2'] = c2/scale
+
+        # need xi, d, sld_a, sld_b, phi=volfraction_a
+        # assume contrast is 1.0e-6, scale=1, background=0
+        sld_a, sld_b = 1.0, 0.
+        drho = sld_a - sld_b
+
+        # find xi
+        p_scale = oldpars['scale']
+        p_c1 = oldpars['c1']
+        p_c2= oldpars['c2']
+        i_1 = 0.5*p_c1/p_c2
+        i_2 = math.sqrt(math.fabs(p_scale/p_c2))
+        i_3 = 2/(i_1 + i_2)
+        xi = math.sqrt(math.fabs(i_3))
+
+        # find d from xi
+        k = math.sqrt(math.fabs(1 - 0.5*p_c1/p_c2*xi**2))
+        d = 2*math.pi*xi/k
+
+        # solve quadratic phi (1-phi) = xi/(1e-4 8 pi drho^2 c2)
+        # favour volume fraction in [0, 0.5]
+        c = xi / (1e-4 * 8.0 * math.pi * drho**2 * p_c2)
+        phi = 0.5 - math.sqrt(0.25 - c)
+
+        # scale sld_a by 1e-6 because the translator will scale it back
+        oldpars.update(volfraction_a=phi, xi=xi, d=d, sld_a=sld_a*1e-6,
+                       sld_b=sld_b, scale=1.0)
+        oldpars.pop('c1')
+        oldpars.pop('c2')
+
+    return oldpars
+
+def convert_model(name, pars, use_underscore=False, model_version=(3,1,2)):
     """
     Convert model from old style parameter names to new style.
     """
-    _, _ = name, pars # lint
-    raise NotImplementedError
-    # need to load all new models in order to determine old=>new
-    # model name mapping
-
-def _unscale(par, scale):
-    return [pk*scale for pk in par] if isinstance(par, list) else par*scale
-
-def _is_sld(modelinfo, id):
-    if id.startswith('M0:'):
-        return True
-    if (id.endswith('_pd') or id.endswith('_pd_n') or id.endswith('_pd_nsigma')
-            or id.endswith('_pd_width') or id.endswith('_pd_type')):
-        return False
-    for p in modelinfo.parameters.call_parameters:
-        if p.id == id:
-            return p.type == 'sld'
-    # check through kernel parameters in case it is a named as a vector
-    for p in modelinfo.parameters.kernel_parameters:
-        if p.id == id:
-            return p.type == 'sld'
-    raise ValueError("unknown parameter %r in conversion"%id)
-
-def _unscale_sld(modelinfo, pars):
-    """
-    rescale all sld parameters in the new model definition by 1e6 so the
-    numbers are nicer.  Relies on the fact that all sld parameters in the
-    new model definition end with sld.
-    """
-    return dict((id, (_unscale(v, 1e-6) if _is_sld(modelinfo, id) else v))
-                for id, v in pars.items())
-
-def _remove_pd(pars, key, name):
-    """
-    Remove polydispersity from the parameter list.
-
-    Note: operates in place
-    """
-    # Bumps style parameter names
-    width = pars.pop(key+".width", 0.0)
-    n_points = pars.pop(key+".npts", 0)
-    if width != 0.0 and n_points != 0:
-        warnings.warn("parameter %s not polydisperse in sasview %s"%(key, name))
-    pars.pop(key+".nsigmas", None)
-    pars.pop(key+".type", None)
-    return pars
+    newpars = pars
+    keys = sorted(CONVERSION_TABLE.keys())
+    for i, version in enumerate(keys):
+        # Don't allow indices outside list
+        next_i = i + 1
+        if next_i == len(keys):
+            next_i = i
+        # If the save state is from a later version, skip the check
+        if model_version <= keys[next_i]:
+            newname = _conversion_target(name, version)
+        else:
+            newname = None
+        # If no conversion is found, move on
+        if newname is None:
+            newname = name
+            continue
+        if ':' in newname:   # core_shell_ellipsoid:1
+            model_info = load_model_info(newname[:-2])
+            # Know the table exists and isn't multiplicity so grab it directly
+            # Can't use _get_translation_table since that will return the 'bare'
+            # version.
+            translation = CONVERSION_TABLE.get(version, {})[newname][1]
+        else:
+            model_info = load_model_info(newname)
+            translation = _get_translation_table(model_info, version)
+        newpars = _hand_convert(newname, newpars, version)
+        newpars = _convert_pars(newpars, translation)
+        # TODO: Still not convinced this is the best check
+        if not model_info.structure_factor and version == (3,1,2):
+            newpars = _rescale_sld(model_info, newpars, 1e6)
+        newpars.setdefault('scale', 1.0)
+        newpars.setdefault('background', 0.0)
+        if use_underscore:
+            newpars = _pd_to_underscores(newpars)
+        name = newname
+    return newname, newpars
+
+# ========= BACKWARD CONVERSION sasmodels => sasview 3.x ===========
 
 def _revert_pars(pars, mapping):
@@ -146,19 +363,18 @@
     return oldname
 
-def _get_translation_table(model_info):
-    _, translation = CONVERSION_TABLE.get(model_info.id, [None, {}])
-    translation = translation.copy()
-    for p in model_info.parameters.kernel_parameters:
-        if p.length > 1:
-            newid = p.id
-            oldid = translation.get(p.id, p.id)
-            translation.pop(newid, None)
-            for k in range(1, p.length+1):
-                if newid+str(k) not in translation:
-                    translation[newid+str(k)] = oldid+str(k)
-    # Remove control parameter from the result
-    if model_info.control:
-        translation[model_info.control] = "CONTROL"
-    return translation
+def _remove_pd(pars, key, name):
+    """
+    Remove polydispersity from the parameter list.
+
+    Note: operates in place
+    """
+    # Bumps style parameter names
+    width = pars.pop(key+".width", 0.0)
+    n_points = pars.pop(key+".npts", 0)
+    if width != 0.0 and n_points != 0:
+        warnings.warn("parameter %s not polydisperse in sasview %s"%(key, name))
+    pars.pop(key+".nsigmas", None)
+    pars.pop(key+".type", None)
+    return pars
 
 def _trim_vectors(model_info, pars, oldpars):
@@ -180,6 +396,6 @@
         composition_type, parts = model_info.composition
         if composition_type == 'product':
-            translation = {'scale':'scale_factor'}
-            translation.update(_get_translation_table(parts[0]))
+            translation = _get_translation_table(parts[0])
+            # structure factor models include scale:scale_factor mapping
             translation.update(_get_translation_table(parts[1]))
         else:
@@ -187,5 +403,5 @@
     else:
         translation = _get_translation_table(model_info)
-    oldpars = _revert_pars(_unscale_sld(model_info, pars), translation)
+    oldpars = _revert_pars(_rescale_sld(model_info, pars, 1e-6), translation)
     oldpars = _trim_vectors(model_info, pars, oldpars)
 
@@ -215,29 +431,4 @@
         if name in MODELS_WITHOUT_VOLFRACTION:
             del oldpars['volfraction']
-        if name == 'stacked_disks':
-            _remove_pd(oldpars, 'n_stacking', name)
-        elif name == 'pearl_necklace':
-            _remove_pd(oldpars, 'num_pearls', name)
-            _remove_pd(oldpars, 'thick_string', name)
-        elif name == 'core_shell_parallelepiped':
-            _remove_pd(oldpars, 'rimA', name)
-            _remove_pd(oldpars, 'rimB', name)
-            _remove_pd(oldpars, 'rimC', name)
-        elif name == 'polymer_micelle':
-            if 'ndensity' in oldpars:
-                oldpars['ndensity'] *= 1e15
-        elif name == 'spherical_sld':
-            oldpars["CONTROL"] -= 1
-            # remove polydispersity from shells
-            for k in range(1, 11):
-                _remove_pd(oldpars, 'thick_flat'+str(k), 'thickness')
-                _remove_pd(oldpars, 'thick_inter'+str(k), 'interface')
-            # remove extra shells
-            for k in range(int(pars['n_shells']), 11):
-                oldpars.pop('sld_flat'+str(k), 0)
-                oldpars.pop('thick_flat'+str(k), 0)
-                oldpars.pop('thick_inter'+str(k), 0)
-                oldpars.pop('func_inter'+str(k), 0)
-                oldpars.pop('nu_inter'+str(k), 0)
         elif name == 'core_multi_shell':
             # kill extra shells
@@ -252,8 +443,21 @@
         elif name == 'core_shell_parallelepiped':
             _remove_pd(oldpars, 'rimA', name)
-        elif name in ['mono_gauss_coil', 'poly_gauss_coil']:
-            del oldpars['i_zero']
+            _remove_pd(oldpars, 'rimB', name)
+            _remove_pd(oldpars, 'rimC', name)
+        elif name == 'hollow_cylinder':
+            # now uses radius and thickness
+            thickness = oldpars['core_radius']
+            oldpars['radius'] += thickness
+            oldpars['radius.width'] *= thickness/oldpars['radius']
+        #elif name in ['mono_gauss_coil', 'poly_gauss_coil']:
+        #    del oldpars['i_zero']
         elif name == 'onion':
             oldpars.pop('n_shells', None)
+        elif name == 'pearl_necklace':
+            _remove_pd(oldpars, 'num_pearls', name)
+            _remove_pd(oldpars, 'thick_string', name)
+        elif name == 'polymer_micelle':
+            if 'ndensity' in oldpars:
+                oldpars['ndensity'] *= 1e15
         elif name == 'rpa':
             # convert scattering lengths from femtometers to centimeters
@@ -272,4 +476,36 @@
                 for k in "Kab,Kac,Kad".split(','):
                     oldpars.pop(k, None)
+        elif name == 'spherical_sld':
+            oldpars["CONTROL"] -= 1
+            # remove polydispersity from shells
+            for k in range(1, 11):
+                _remove_pd(oldpars, 'thick_flat'+str(k), 'thickness')
+                _remove_pd(oldpars, 'thick_inter'+str(k), 'interface')
+            # remove extra shells
+            for k in range(int(pars['n_shells']), 11):
+                oldpars.pop('sld_flat'+str(k), 0)
+                oldpars.pop('thick_flat'+str(k), 0)
+                oldpars.pop('thick_inter'+str(k), 0)
+                oldpars.pop('func_inter'+str(k), 0)
+                oldpars.pop('nu_inter'+str(k), 0)
+        elif name == 'stacked_disks':
+            _remove_pd(oldpars, 'n_stacking', name)
+        elif name == 'teubner_strey':
+            # basically redoing the entire Teubner-Strey calculations here.
+            volfraction = oldpars.pop('volfraction_a')
+            xi = oldpars.pop('xi')
+            d = oldpars.pop('d')
+            sld_a = oldpars.pop('sld_a')
+            sld_b = oldpars.pop('sld_b')
+            drho = 1e6*(sld_a - sld_b)  # conversion autoscaled these
+            k = 2.0*math.pi*xi/d
+            a2 = (1.0 + k**2)**2
+            c1 = 2.0 * xi**2 * (1.0 - k**2)
+            c2 = xi**4
+            prefactor = 8.0*math.pi*volfraction*(1.0-volfraction)*drho**2*c2/xi
+            scale = 1e-4*prefactor
+            oldpars['scale'] = a2/scale
+            oldpars['c1'] = c1/scale
+            oldpars['c2'] = c2/scale
 
     #print("convert from",list(sorted(pars)))
@@ -315,20 +551,22 @@
         if name in MODELS_WITHOUT_VOLFRACTION:
             pars['volfraction'] = 1
-        if name == 'pearl_necklace':
-            pars['string_thickness_pd_n'] = 0
-            pars['number_of_pearls_pd_n'] = 0
+        if name == 'core_multi_shell':
+            pars['n'] = min(math.ceil(pars['n']), 4)
+        elif name == 'gel_fit':
+            pars['scale'] = 1
         elif name == 'line':
             pars['scale'] = 1
             pars['background'] = 0
+        elif name == 'mono_gauss_coil':
+            pars['scale'] = 1
+        elif name == 'onion':
+            pars['n_shells'] = math.ceil(pars['n_shells'])
+        elif name == 'pearl_necklace':
+            pars['string_thickness_pd_n'] = 0
+            pars['number_of_pearls_pd_n'] = 0
+        elif name == 'poly_gauss_coil':
+            pars['scale'] = 1
         elif name == 'rpa':
             pars['case_num'] = int(pars['case_num'])
-        elif name == 'mono_gauss_coil':
-            pars['i_zero'] = 1
-        elif name == 'poly_gauss_coil':
-            pars['i_zero'] = 1
-        elif name == 'core_multi_shell':
-            pars['n'] = min(math.ceil(pars['n']), 4)
-        elif name == 'onion':
-            pars['n_shells'] = math.ceil(pars['n_shells'])
         elif name == 'spherical_sld':
             pars['n_shells'] = math.ceil(pars['n_shells'])
@@ -339,3 +577,56 @@
                 pars['thickness%d_pd_n'%k] = 0
                 pars['interface%d_pd_n'%k] = 0
-
+        elif name == 'teubner_strey':
+            pars['scale'] = 1
+            if pars['volfraction_a'] > 0.5:
+                pars['volfraction_a'] = 1.0 - pars['volfraction_a']
+        elif name == 'unified_power_Rg':
+            pars['level'] = int(pars['level'])
+
+def _check_one(name, seed=None):
+    """
+    Generate a random set of parameters for *name*, and check that they can
+    be converted back to SasView 3.x and forward again to sasmodels.  Raises
+    an error if the parameters are changed.
+    """
+    from . import compare
+
+    model_info = load_model_info(name)
+
+    old_name = revert_name(model_info)
+    if old_name is None:
+        return
+
+    pars = compare.get_pars(model_info, use_demo=False)
+    pars = compare.randomize_pars(model_info, pars, seed=seed)
+    if name == "teubner_strey":
+        # T-S model is underconstrained, so fix the assumptions.
+        pars['sld_a'], pars['sld_b'] = 1.0, 0.0
+    compare.constrain_pars(model_info, pars)
+    constrain_new_to_old(model_info, pars)
+    old_pars = revert_pars(model_info, pars)
+    new_name, new_pars = convert_model(old_name, old_pars, use_underscore=True)
+    if 1:
+        print("==== %s in ====="%name)
+        print(str(compare.parlist(model_info, pars, True)))
+        print("==== %s ====="%old_name)
+        for k, v in sorted(old_pars.items()):
+            print(k, v)
+        print("==== %s out ====="%new_name)
+        print(str(compare.parlist(model_info, new_pars, True)))
+    assert name==new_name, "%r != %r"%(name, new_name)
+    for k, v in new_pars.items():
+        assert k in pars, "%s: %r appeared from conversion"%(name, k)
+        if isinstance(v, float):
+            assert abs(v-pars[k])<=abs(1e-12*v), "%s: %r  %s != %s"%(name, k, v, pars[k])
+        else:
+            assert v == pars[k], "%s: %r  %s != %s"%(name, k, v, pars[k])
+    for k, v in pars.items():
+        assert k in pars, "%s: %r not converted"%(name, k)
+
+def test_backward_forward():
+    from .core import list_models
+    for name in list_models('all'):
+        L = lambda: _check_one(name, seed=1)
+        L.description = name
+        yield L
Index: sasmodels/core.py
===================================================================
--- sasmodels/core.py	(revision 1875f4ec2447bb528be359e5369f6574d604860f)
+++ sasmodels/core.py	(revision 52e9a450543ba1ed18c9b30bfe89ce5288d4a831)
@@ -53,5 +53,5 @@
          "nonmagnetic", "magnetic")
 def list_models(kind=None):
-    # type: () -> List[str]
+    # type: (str) -> List[str]
     """
     Return the list of available models on the model path.
Index: sasmodels/details.py
===================================================================
--- sasmodels/details.py	(revision 6dc78e4926d9f0e39bbb55c42a8f11b256f166fd)
+++ sasmodels/details.py	(revision ccd5f018ad394bf78c2726b92d428f6903233b21)
@@ -230,5 +230,5 @@
     npars = kernel.info.parameters.npars
     nvalues = kernel.info.parameters.nvalues
-    scalars = [v[0][0] for v in pairs]
+    scalars = [(v[0] if len(v) else np.NaN) for v, w in pairs]
     values, weights = zip(*pairs[2:npars+2]) if npars else ((),())
     length = np.array([len(w) for w in weights])
Index: sasmodels/generate.py
===================================================================
--- sasmodels/generate.py	(revision 234c53299996393b4b998f41d2eea755356d9a75)
+++ sasmodels/generate.py	(revision 1e7b0db0b7b4315c62b59e1d659332bcbc962b8f)
@@ -139,5 +139,5 @@
     square(x) = x*x
     cube(x) = x*x*x
-    sinc(x) = sin(x)/x, with sin(0)/0 -> 1
+    sas_sinx_x(x) = sin(x)/x, with sin(0)/0 -> 1
     all double precision constants must include the decimal point
     all double declarations may be converted to half, float, or long double
@@ -166,4 +166,5 @@
 import re
 import string
+from zlib import crc32
 
 import numpy as np  # type: ignore
@@ -356,4 +357,11 @@
     return newest
 
+def tag_source(source):
+    # type: (str) -> str
+    """
+    Return a unique tag for the source code.
+    """
+    # Note: need 0xffffffff&val to force an unsigned 32-bit number
+    return "%08X"%(0xffffffff&crc32(source))
 
 def convert_type(source, dtype):
Index: sasmodels/kernel_header.c
===================================================================
--- sasmodels/kernel_header.c	(revision e1d6983831831051b424a8d021b337435d87f0f3)
+++ sasmodels/kernel_header.c	(revision 1e7b0db0b7b4315c62b59e1d659332bcbc962b8f)
@@ -146,4 +146,36 @@
 inline double square(double x) { return x*x; }
 inline double cube(double x) { return x*x*x; }
-inline double sinc(double x) { return x==0 ? 1.0 : sin(x)/x; }
+inline double sas_sinx_x(double x) { return x==0 ? 1.0 : sin(x)/x; }
 
+#if 1
+//think cos(theta) should be sin(theta) in new coords, RKH 11Jan2017
+#define ORIENT_SYMMETRIC(qx, qy, theta, phi, q, sn, cn) do { \
+    SINCOS(phi*M_PI_180, sn, cn); \
+    q = sqrt(qx*qx + qy*qy); \
+    cn  = (q==0. ? 1.0 : (cn*qx + sn*qy)/q * sin(theta*M_PI_180));  \
+    sn = sqrt(1 - cn*cn); \
+    } while (0)
+#else
+// SasView 3.x definition of orientation
+#define ORIENT_SYMMETRIC(qx, qy, theta, phi, q, sn, cn) do { \
+    SINCOS(theta*M_PI_180, sn, cn); \
+    q = sqrt(qx*qx + qy*qy);\
+    cn = (q==0. ? 1.0 : (cn*cos(phi*M_PI_180)*qx + sn*qy)/q); \
+    sn = sqrt(1 - cn*cn); \
+    } while (0)
+#endif
+
+#define ORIENT_ASYMMETRIC(qx, qy, theta, phi, psi, q, cos_alpha, cos_mu, cos_nu) do { \
+    q = sqrt(qx*qx + qy*qy); \
+    const double qxhat = qx/q; \
+    const double qyhat = qy/q; \
+    double sin_theta, cos_theta; \
+    double sin_phi, cos_phi; \
+    double sin_psi, cos_psi; \
+    SINCOS(theta*M_PI_180, sin_theta, cos_theta); \
+    SINCOS(phi*M_PI_180, sin_phi, cos_phi); \
+    SINCOS(psi*M_PI_180, sin_psi, cos_psi); \
+    cos_alpha = cos_theta*cos_phi*qxhat + sin_theta*qyhat; \
+    cos_mu = (-sin_theta*cos_psi*cos_phi - sin_psi*sin_phi)*qxhat + cos_theta*cos_psi*qyhat; \
+    cos_nu = (-cos_phi*sin_psi*sin_theta + sin_phi*cos_psi)*qxhat + sin_psi*cos_theta*qyhat; \
+    } while (0)
Index: sasmodels/kernel_template.c
===================================================================
--- sasmodels/kernel_template.c	(revision 0d6e86566d51a1fba22933bdbac8c40d36f9bd76)
+++ sasmodels/kernel_template.c	(revision 1e7b0db0b7b4315c62b59e1d659332bcbc962b8f)
@@ -133,5 +133,5 @@
 inline double square(double x) { return x*x; }
 inline double cube(double x) { return x*x*x; }
-inline double sinc(double x) { return x==0 ? 1.0 : sin(x)/x; }
+inline double sas_sinx_x(double x) { return x==0 ? 1.0 : sin(x)/x; }
 
 
Index: sasmodels/kernelcl.py
===================================================================
--- sasmodels/kernelcl.py	(revision b8ddf2ee294b766f2a52d72f50c588327b403bb7)
+++ sasmodels/kernelcl.py	(revision b8ddf2ee294b766f2a52d72f50c588327b403bb7)
@@ -294,5 +294,6 @@
         # so we don't really need to cache things for ourselves.  I'll do so
         # anyway just to save some data munging time.
-        key = "%s-%s%s"%(name, dtype, ("-fast" if fast else ""))
+        tag = generate.tag_source(source)
+        key = "%s-%s-%s%s"%(name, dtype, tag, ("-fast" if fast else ""))
         # Check timestamp on program
         program, program_timestamp = self.compiled.get(key, (None, np.inf))
Index: sasmodels/modelinfo.py
===================================================================
--- sasmodels/modelinfo.py	(revision ca55aa04dd10f098b6cec84f2f11c026f1949bbe)
+++ sasmodels/modelinfo.py	(revision 85fe7f81bca37e67a39808fbf8e07e7d8be316b1)
@@ -548,5 +548,5 @@
         return full_list
 
-    def user_parameters(self, pars={}, is2d=True):
+    def user_parameters(self, pars, is2d=True):
         # type: (Dict[str, float], bool) -> List[Parameter]
         """
